package server;

import java.rmi.*;
import java.rmi.server.UnicastRemoteObject;

import java.util.*;


import common.ChatServer;
import common.ChatClient;
import common.Message;


public class ChatServerImpl extends UnicastRemoteObject
    implements ChatServer {

    private LinkedList myclients;


    public ChatServerImpl() throws java.rmi.RemoteException {
	myclients = new LinkedList();
    }


    public synchronized void register( ChatClient c ) throws java.rmi.RemoteException {

	System.out.println("Registering a new client...");
	myclients.add( c );
    }

    public synchronized void deregister( ChatClient c ) throws java.rmi.RemoteException {

	System.out.println("Deregistering a client...");
	myclients.remove( c );
    }


    public synchronized void broadcast( Message m ) throws java.rmi.RemoteException {
	ListIterator it = myclients.listIterator(0);
	ChatClient c;
	int i = 0;

	System.out.println("Broadcast called...");

	while( it.hasNext() ) {
	    c = (ChatClient) it.next();

	    System.out.println("Sending message to client " + ++i);
	    c.receive( m );
	}
    }

    public static void main( String[] args ) {
	try {
	    System.out.println("Starting the server.");
	    Naming.rebind( "ChatServer", new ChatServerImpl( ) );
	} catch( Exception ex ) {
	    System.err.println("Binding the server failed!");
	    ex.printStackTrace();
	}
    }

}
